<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <v-form v-if="formState.ready" ref="form">
      <v-row dense>
        <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
        <v-col cols="12">
          <gz-pick-list
            v-model="obj.unitId"
            readonly
            :aya-type="ayaTypes().Unit"
            show-edit-icon
            :label="$ay.t('Unit')"
          ></gz-pick-list>
        </v-col>
        <v-col cols="12" sm="6" lg="4" xl="3">
          <v-text-field
            ref="meter"
            v-model="obj.meter"
            dense
            :readonly="formState.readOnly"
            :clearable="!formState.readOnly"
            :label="$ay.t('UnitMeterReadingMeter')"
            data-cy="meter"
            :rules="[form().integerValid(this, 'meter')]"
            :error-messages="form().serverErrors(this, 'meter')"
            type="number"
            @click:clear="fieldValueChanged('meter')"
            @input="fieldValueChanged('meter')"
          ></v-text-field>
        </v-col>

        <v-col cols="12" sm="6" lg="4" xl="3">
          <v-textarea
            ref="notes"
            v-model="obj.notes"
            dense
            :readonly="formState.readOnly"
            :label="$ay.t('UnitMeterReadingDescription')"
            :error-messages="form().serverErrors(this, 'notes')"
            data-cy="notes"
            auto-grow
            :clearable="!formState.readOnly"
            @input="fieldValueChanged('notes')"
          ></v-textarea>
        </v-col>
        <v-col cols="12" sm="6" lg="4" xl="3">
          <gz-date-time-picker
            ref="meterDate"
            v-model="obj.meterDate"
            :label="$ay.t('UnitMeterReadingMeterDate')"
            :readonly="formState.readOnly"
            data-cy="meterDate"
            :error-messages="form().serverErrors(this, 'meterDate')"
            @input="fieldValueChanged('meterDate')"
          ></gz-date-time-picker>
        </v-col>
      </v-row>
    </v-form>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "meter-reading";
const API_BASE_URL = "unit/meter-reading/";
export default {
  data() {
    return {
      obj: {
        id: 0,
        concurrency: 0,
        notes: null,
        meter: 0,
        meterDate: window.$gz.locale.nowUTC8601String(),
        unitId: undefined,
        workOrderItemUnitId: undefined
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.UnitMeterReading
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.Unit);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
          window.$gz.form.setFormState({
            vm: vm,
            loading: false,
            readOnly: true
          });
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        vm.obj.unitId = this.$route.params.unitid;
        vm.obj.workOrderItemUnitId = this.$route.params.workorderitemunitid;
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
      window.$gz.form.setFormState({
        vm: vm,
        dirty: false,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false,
            readOnly: true
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "meter-reading",
              params: {
                recordid: res.data.id,
                unitid: res.data.unitId,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "new":
        m.vm.$router.push({
          name: "meter-reading",
          params: { recordid: 0, unitid: m.vm.obj.unitId }
        });
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.UnitMeterReading,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiWeight",
    title: "UnitMeterReading",
    helpUrl: "svc-meter-readings",
    formData: {
      ayaType: window.$gz.type.UnitMeterReading,
      recordId: vm.$route.params.recordid
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  // if (vm.rights.change) {
  //   menuOptions.menuItems.push({
  //     title: "New",
  //     icon: "$ayiPlus",
  //     key: FORM_KEY + ":new",
  //     vm: vm
  //   });
  // }

  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm() {
  await fetchTranslatedText();
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "UnitMeterReading",
    "UnitMeterReadingDescription",
    "UnitMeterReadingMeter",
    "UnitMeterReadingMeterDate",
    "UnitMeterReadingWorkOrderItemID"
  ]);
}
</script>
